/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

UCNiColor)
OpenGL + GLSL
*/

//摜t@C
#define FILENAME_IN "../../bmp256/tiger1-1.bmp"

//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../bmpLoadSave.h"

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void drawPlate();
void setTexture();
void special(int key, int x, int y);
void mouse(int button, int state, int x, int y);
void motion(int x, int y);

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qy0;//
//VF[_vO
GLuint program;
//ubN1si܂1jf
int nPixel = 10;
//wvL[tO
bool flagHelp = false;
//}EX
float posMouse[] = {0.0, 0.0};
float radius = 30.0;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGB);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_Mosaic2");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
	initGlsl(&program, "mosaic2.vert", "mosaic2.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteProgram(program);
  return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.2, 0.2, 0.2, 1.0);
	//J[摜̎擾
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	posMouse[0] = (float)imgWidth / 2.0;
	posMouse[1] = (float)imgHeight / 2.0;
	setTexture();
  printf("}EX/L[̐ɂ'H'L[vbV \n");
}


void setTexture()
{
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);//NEAREST);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);//NEAREST);
}

void display(void)
{
	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

	//摜
  // VF[_vO̓Kp 
  glUseProgram(program);
  GLint imageLoc = glGetUniformLocation(program, "image");
  glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint imgWidthLoc = glGetUniformLocation(program, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint nPixelLoc = glGetUniformLocation(program, "nPixel");
	glUniform1i(nPixelLoc, nPixel);
	GLint posMLoc = glGetUniformLocation(program, "posMouse");
	glUniform2fv(posMLoc, 1, posMouse);
	GLint radiusLoc = glGetUniformLocation(program, "radius");
	glUniform1f(radiusLoc, radius);
	
	qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;

	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	drawPlate();
	glPopMatrix();
  // VF[_vỎ 
  glUseProgram(0);

	if(flagHelp)
  {
		printf("[F1]L[FubNf(nPixel)̑ \n");
		printf("[F2]L[FUCNa(radius)̑ \n");
		printf("}EX{^ŃUCN̈ʒuύX \n");
		flagHelp = false;
  }
  //I
	glFlush();
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒ
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, image);
		saveBitmap24(imgWidth, imgHeight, image, FILENAME_OUT); 
	  break;

  case 'h':
		flagHelp = !flagHelp;
		display();
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) nPixel += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	nPixel -= 1;  
		if(nPixel < 1) nPixel = 1;
		printf("ubNf = %d \n", nPixel*nPixel);
	}	
	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) radius += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	radius -= 1.0;  
		if(radius < 5.0) radius = 5.0;
		printf("UCNa = %f \n", radius);
	}	
	display();
}

//ȉ2̊֐̓}EXɕKv
void mouse(int button, int state, int x, int y)
{
  if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
  {
	  posMouse[0] = x - px0; 
		posMouse[1] = y - py0;
  }
	display();
}

void motion(int x, int y)
{
  posMouse[0] = (x - px0);
  posMouse[1] = (y - py0);
	display();
}
