
void calcWeight(out float ww[4], in float t, in float g)
{//Catmull-Rom
	float t2 = t * t;
	float t3 = t2 * t;
	ww[0] = g * (-0.5 * t3 + t2 - 0.5 * t);
	ww[1] = (2.0 - 0.5*g) * t3 - (3.0 - 0.5*g) * t2 + 1.0;
	ww[2] = (0.5*g - 2.0) * t3 + (3.0 - g) * t2 + 0.5 * g * t;
	ww[3] = 0.5 * g * (t3 - t2);
}

uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform float ratio;//g嗦
uniform int type;
uniform float g;
varying vec2 pos;
//1f̋
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	vec4 col;

  if(type == 0)//NEAREST
  {
		vec2 pos0 = floor(pos / ratio + vec2(0.5, 0.5));
		vec2 texCoord = vec2(pos0.x * dx, pos0.y * dy);
		col = texture2D(image, texCoord);
	}
	else if(type == 1)//BILINEAR
	{
		vec2 pos1 = floor(pos / ratio);
		vec2 pos2 = pos1 + vec2(1.0, 1.0);
		vec2 pq = fract(pos / ratio);
		vec4 col11 = texture2D(image, vec2(pos1.x * dx, pos1.y * dy));
		vec4 col21 = texture2D(image, vec2(pos2.x * dx, pos1.y * dy));
		vec4 col12 = texture2D(image, vec2(pos1.x * dx, pos2.y * dy));
		vec4 col22 = texture2D(image, vec2(pos2.x * dx, pos2.y * dy));
		col = mix(mix(col11, col21, pq.x), mix(col12, col22, pq.x), pq.y);
	}
	else//BICUBIC
	{
		int ii, jj;
		vec2 pos0[4];
		pos0[1] = floor(pos / ratio);//Z(1,1)̈ʒu(ړ_̍j
		pos0[0] = pos0[1] - vec2(1.0);//Z(0,0)
		pos0[2] = pos0[1] + vec2(1.0);//Z(2,2)
		pos0[3] = pos0[1] + vec2(2.0);//Z(3,3)
		vec2 t = fract(pos / ratio);//ړ_Z(1,1)f܂ł̋
		float weightX[4], weightY[4];//d
		//catmull-Rom
		calcWeight(weightX, t.x, g);
		calcWeight(weightY, t.y, g);

    //ߖT16_̉fl
		vec4 c[16];
		for(jj = 0; jj < 4; jj++)
			for(ii = 0; ii < 4; ii++)		
			{
				c[ii + 4*jj] = texture2D(image, vec2(pos0[ii].x * dx, pos0[jj].y * dy));
			}
		vec4 cc[4];
		//esɂ
		for(jj = 0; jj < 4; jj++) 
		{
			cc[jj] = vec4(0.0);
			for(ii = 0; ii < 4; ii++) cc[jj] += c[ii + 4*jj] * weightX[ii];
		}
		//sԒlcc[jj]pďc̕ԒlvZ
		col = vec4(0.0);
		for(jj = 0; jj < 4; jj++) col += cc[jj] * weightY[jj];
	}
	gl_FragColor.rgb = col.rgb;
}