uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform int levelA, levelB, levelC, levelD;
varying vec2 pos;
const float zMax = 1.0;

void main(void)
{
	float a = float(levelA) / 255.0;
	float b = float(levelB) / 255.0;
	float c = float(levelC) / 255.0;
	float d = float(levelD) / 255.0;
	
	vec2 texCoord = vec2(pos.x / float(imgWidth), pos.y / float(imgHeight));
	vec3 col = texture2D(image, texCoord).rgb;//摜
	vec3 newCol;

	if(col.r < a)
		newCol = (c / a) * col;
	else if(col.r < b) 
	  newCol = (d - c) * (col - a) / (b - a) + c;
	else
	  newCol = ((col - b) / (zMax - b)) * (zMax - d) + d;

	gl_FragColor = vec4(newCol, 1.0);
}