uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform float gamma1, gamma2;
uniform int levelCenter;
varying vec2 pos;

void main(void)
{
	float center = float(levelCenter) / 255.0;
	vec2 texCoord = vec2(pos.x / float(imgWidth), pos.y / float(imgHeight));
	vec3 col = texture2D(image, texCoord).rgb;//摜
	vec3 newCol;
	
	if(col.r < center) 
		newCol.r = center * pow(col.r / center, vec3(gamma1));
	else
		newCol.r = center + (1.0 - center) *  pow((col.r  - center)/(1.0 - center), vec3(gamma2));

	if(col.g < center) 
		newCol.g = center * pow(col.g / center, vec3(gamma1));
	else
		newCol.g = center + (1.0 - center) *  pow((col.g  - center)/(1.0 - center), vec3(gamma2));

	if(col.b < center) 
		newCol.b = center * pow(col.b / center, vec3(gamma1));
	else
		newCol.b = center + (1.0 - center) *  pow((col.b  - center)/(1.0 - center), vec3(gamma2));

	gl_FragColor = vec4(newCol, 1.0);
}