
const float pi =  3.14159265358979;
const int LPF = 0;
const int HPF = 1;
const int RECTANGLE = 0;
const int HAMMING = 1;
const int HANNING = 2;

void createImpulse(int nTap, float cutoff, int typeFilter, int typeWindow, out float h[10])
{
	int k;
	float h0[10];
	float cut;

	int nt = (nTap - 1) / 2 ; //Sh(0)Б^bv

	if( typeFilter == LPF)
	{
		cut = cutoff;
		h0[0] = cut;
		for( k = 1; k <= nt; k++)
			h0[k] = cut * sin(float(k) * cut * pi) / (float(k) * cut * pi);
	}
	else//HPF
	{
		cut = 1.0 - cutoff;
		h0[0] = cut;
		for( k = 1; k <= nt; k++)
		{ 
			h0[k] = cut * sin(float(k) * cut * pi) / (float(k) * cut * pi);
			if(mod(float(k), 2.0) != 0.0) h0[k] = - h0[k];
		}
	}
    
	if(typeWindow == RECTANGLE)
	{
		  //
		  for( k = 0; k <= nt; k++) h[k] = h0[k];
	}
	else if(typeWindow == HAMMING)
	{
			for( k = 0; k <= nt; k++)
				h[k] = h0[k] * (0.54 + 0.46 * cos(float(k) * pi / float(nt)));
	}
	else//HANNING
	{
		  for( k = 0; k <= nt; k++)
			  h[k] = h0[k] * (0.5 + 0.5 * cos(float(k) * pi / float(nt)));
	}
}
//-----------------------------------------------------------
uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform int nTap;
uniform float cutoff;
uniform int typeFilter, typeWindow;
varying vec2 pos;
//1f̋
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	int i, j, k;
	int nWeight = nTap * nTap;
	float hh[10];
	
	createImpulse(nTap, cutoff, typeFilter, typeWindow, hh);
	int nt = (nTap - 1) / 2 ; //Sh(0)Б^bv
	vec2 offset;
	float weight;

	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 col = vec3(0.0);
	float sum = 0.0;
	//CASCADE only
	for(j = 0; j < nTap; j++)
		for(i = 0; i < nTap; i++)
	  {
			offset = vec2(float(-nt + i) * dx, float(-nt + j) * dy) ;
		  weight = hh[abs(i-nt)] * hh[abs(j-nt)];
			sum += weight;
			col += texture2D(image, texCoord + offset).rgb * weight;
		}

	if(typeFilter == LPF)
	{//weight̍v1.0ɂȂ悤ɐK
		col /= sum;
	}
	else {col += 0.5;}
	gl_FragColor = vec4(col, 1.0);
}
