
uniform sampler2D samplerGrad;
uniform int imgWidth, imgHeight;
uniform float thresh;
varying vec2 pos;
float w = 1.0 / float(imgWidth);
float h = 1.0 / float(imgHeight);

const float c = 0.5 / sin(3.14459265 / 8.0);

void main(void)
{
	vec3 col;
	vec2 texCoord = vec2(pos.x * w, pos.y * h);
	vec4 grad = texture2D(samplerGrad, texCoord);
	grad.xy -= vec2(0.5);
	//z̗ʎq
	vec2 offset = floor( c * grad.xy / grad.z + 0.5 ) * vec2(w, h);
	//Oь̌z̑傫߂
	vec4 fwdNB = texture2D(samplerGrad, texCoord + offset);
	vec4 bckNB = texture2D(samplerGrad, texCoord - offset);
	//ő}
	if(grad.z > fwdNB.z  && grad.z > bckNB.z)	
		col = vec4(0.0);//edge
	else 
		col = vec4(1.0);//non edge

	if(grad.z < thresh) col = vec4(1.0);//non edge
	gl_FragColor = vec4(col, 1.0);
}