uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform int size;//tB^TCY
uniform float sigma;//W΍
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);
float sigma2 = sigma * sigma;
float sigma4 = sigma2 * sigma2;
float a = 1.0 / (2.0*sigma4);


void main(void)
{
	int i, j, ii, jj;
	int n0 = (size-1)/2;
	vec2 weight;
	vec2 offset;

	vec2 grad = vec2(0.0);
	float mag = 0.0;
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);

	//gaussian gradient operatorid݁ǰvZ
	float b;
	for(jj = 0; jj < size; jj++)		
	{
		j = -n0 + jj;
		for(ii = 0; ii < size; ii++)
		{ 
			offset = vec2(float(-n0 + ii) * dx, float(-n0 + jj) * dy) ;
			i = -n0 + ii;
			b =  a * exp(-float(i*i + j*j) / (2.0 * sigma2));
			weight = - vec2(float(i), float(j)) * b;
			grad += texture2D(image, texCoord + offset).r * weight;
		}
	}

	//zт̑傫[0,1]͈̔͂Ɏ߂
	mag = sqrt(grad.x * grad.x + grad.y * grad.y) / 1.2;
	grad = grad / 2.0 + 0.5;
	vec3 col = vec3(grad.x, grad.y, mag);
	gl_FragColor = vec4(col, 1.0) ;	
}
