uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform int type;//0:PrewittC1:SobelC2:RobertsC3:Laplacian
uniform int gray, inverse, binary, grad;
uniform float threshold;
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	int i, j, k, l;
	vec2 weight[9];
	vec2 offset[9];
	//offseťvZ
	for(int j = 0; j < 3; j++)
		for(int i = 0; i < 3; i++)
		{ 
			offset[i + j * 3] = vec2(float(-1 + i) * dx, float(-1 + j) * dy) ;
		}

	if(type == 0)
	{
		//Prewitt
		//X
		weight[0].x = -1.0; weight[1].x = 0.0; weight[2].x = 1.0;
		weight[3].x = -1.0; weight[4].x = 0.0; weight[5].x = 1.0;
		weight[6].x = -1.0; weight[7].x = 0.0; weight[8].x = 1.0;
		//Y
		weight[0].y = -1.0; weight[1].y =-1.0; weight[2].y =-1.0;
		weight[3].y =  0.0; weight[4].y = 0.0; weight[5].y = 0.0;
		weight[6].y =  1.0; weight[7].y = 1.0; weight[8].y = 1.0;		
	}

	else if(type == 1)
	{
		//Sobel
		//X
		weight[0].x = -1.0; weight[1].x = 0.0; weight[2].x = 1.0;
		weight[3].x = -2.0; weight[4].x = 0.0; weight[5].x = 2.0;
		weight[6].x = -1.0; weight[7].x = 0.0; weight[8].x = 1.0;
		//Y
		weight[0].y = -1.0; weight[1].y =-2.0; weight[2].y =-1.0;
		weight[3].y =  0.0; weight[4].y = 0.0; weight[5].y = 0.0;
		weight[6].y =  1.0; weight[7].y = 2.0; weight[8].y = 1.0;
	}
	else if(type == 2)
	{
		//Roberts
		//X
		weight[0].x = 0.0; weight[1].x = 0.0; weight[2].x = 0.0;
		weight[3].x = 0.0; weight[4].x = 0.0; weight[5].x = 1.0;
		weight[6].x = 0.0; weight[7].x =-1.0; weight[8].x = 0.0;
		//Y
		weight[0].y = 0.0; weight[1].y = 0.0; weight[2].y = 0.0;
		weight[3].y = 0.0; weight[4].y = 1.0; weight[5].y = 0.0;
		weight[6].y = 0.0; weight[7].y = 0.0; weight[8].y =-1.0;		
	}
	else 
	{
		//Laplacian
		weight[0].x = 0.0; weight[1].x = 1.0; weight[2].x = 0.0;
		weight[3].x = 1.0; weight[4].x =-4.0; weight[5].x = 1.0;
		weight[6].x = 0.0; weight[7].x = 1.0; weight[8].x = 0.0;
	}
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 colX = vec3(0.0);
	vec3 colY = vec3(0.0);
	vec3 col = vec3(0.0);;
	//ݍ݉Z
	if(type < 3)//1
	{
		for(k = 0; k < 9; k++) 
		{
			col = texture2D(image, texCoord + offset[k]).rgb;
			colX += col * weight[k].x;
			colY += col * weight[k].y;
		}
		if(grad == 0)
			col = sqrt(colX*colX + colY*colY);
		else if(grad == 1)
			col = abs(colX) + abs(colY);
 		else col = max(abs(colX), abs(colY));
	}
	else//Laplacian
	{
		for(k = 0; k < 9; k++) 
			col += texture2D(image, texCoord + offset[k]).rgb * weight[k].x;
		col += vec3(0.5);//Ԓlǉ
	}
	
	if(gray == 1) //grayscale
		//col = vec3((col.r + col.g + col.b) / 3.0);
		col = vec3(dot(col, vec3(0.299, 0.587, 0.114))); 
	if(inverse == 1)//] 
		col = vec3(1.0) - col;
	if(binary == 1)//2l 
		col = step(threshold, col);
	
	gl_FragColor = vec4(col, 1.0);		
}
