uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform int type;//0:UnsharpC1:UnsharppNs
uniform int size;
uniform float coef;
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	int i, j;
  int Size = size * size;
  int n0 = (size - 1) / 2;
	float weight;
	vec2 offset;
	
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 col = vec3(0.0);

	if(type == 0)
	{
		//UnsharptB^ɂGbWo
		for(j = 0; j < size; j++)
			for(i = 0; i < size; i++)
			{
				offset = vec2(float(-n0 + i) * dx, float(-n0 + j) * dy) ;
				if(i == n0 && j == n0) 
				  weight = float(Size - 1) / float(Size);
			  else weight = - 1.0 / float(Size);
				col += texture2D(image, texCoord + offset) * weight;
			}
	}
	else //(type == 1)
	{
		//UnsharptB^pNs
		for(j = 0; j < size; j++)
			for(i = 0; i < size; i++)
			{
				offset = vec2(float(-n0 + i) * dx, float(-n0 + j) * dy) ;
				if(i == n0 && j == n0) 
				  weight = 1.0 + coef * float(Size - 1) / float(Size);
			  else weight = - coef / float(Size);
				col += texture2D(image, texCoord + offset) * weight;
			}
	}
	gl_FragColor = vec4(col, 1.0);
}
