
uniform sampler2D image1;
uniform sampler2D image2;
uniform int imgWidth, imgHeight;
uniform float alpha;
uniform vec2 posMouse;
uniform float radius;
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 col1 = texture2D(image1, texCoord).rgb;
	vec3 col2 = texture2D(image2, texCoord).rgb;
	posMouse.y = float(imgHeight) - posMouse.y;
	float dist = distance(pos, posMouse);
	if(dist < radius) col1 = mix(col1, col2, alpha);
	gl_FragColor = vec4(col1, 1.0);		
}
