
float getChroma(vec3 col, int space)
{

  float chroma;
	if(space == 0)//YCC
	{
		float C1 = dot(col, vec3(0.701, -0.587, -0.114));
		float C2 = dot(col, vec3(-0.299, -0.587, 0.886));
		chroma = sqrt(C1*C1 + C2*C2);
	}
	else if(space == 1)//HSL
	{
		
		float cmax = max(max(col.r, col.g), col.b);
		float cmin = min(min(col.r, col.g), col.b);
		float lum = (cmin + cmax) / 2.0;
		if(lum <= 0.5) chroma = (cmax - cmin) / (cmax + cmin);
		else chroma = (cmax - cmin) / (2.0 - cmax - cmin);
	}
	else//HSV
	{
		float cmax = max(max(col.r, col.g), col.b);
		float cmin = min(min(col.r, col.g), col.b);
		if(cmax == 0.0) chroma = 0.0;
		else chroma = (cmax - cmin) / cmax;
	}
	return chroma;
}

uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform float threshold;
uniform int space;
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	int i, j, k, l;
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 col = texture2D(image, texCoord).rgb;
	float chroma = getChroma(col, space);
	col = vec3(step(threshold, chroma));	
	gl_FragColor = vec4(col, 1.0);	
}
