float getHueHSLandHSV(float cmax, float cmin, vec3 col)
{
		float hue;
		if(cmax == cmin) hue = 0.0;
		else if(cmax == col.r) 
		  hue = (col.g - col.b) / (cmax - cmin);
		else if(cmax == col.g) 
		  hue = (col.b - col.r) / (cmax - cmin) + 2.0;
		else 
		  hue = (col.r - col.g) / (cmax - cmin) + 4.0;
		hue *= 60.0;
		if(hue < 0.0) hue += 360.0;
		return hue;
}

float getChromaHue(vec3 col, out float hue, int space)
{

  float chroma;
	float cmax = max(max(col.r, col.g), col.b);
	float cmin = min(min(col.r, col.g), col.b);
	if(space == 0)//YCC
	{
		float C1 = dot(col, vec3(0.701, -0.587, -0.114));
		float C2 = dot(col, vec3(-0.299, -0.587, 0.886));
		chroma = sqrt(C1*C1 + C2*C2);
		if(C2 == 0.0) hue = 0.0;
		else hue = degrees(atan(C1, C2));
		hue -= 113.1;//Ԃ
		if(hue < 0.0) hue += 360.0;//hue͈̔[0,360]
		if(hue > 360.0) hue -= 360.0;
	}
	else if(space == 1)//HSL
	{
		float lum = (cmin + cmax) / 2.0;
		if(lum <= 0.5) chroma = (cmax - cmin) / (cmax + cmin);
		else chroma = (cmax - cmin) / (2.0 - cmax - cmin);
		hue = getHueHSLandHSV(cmax, cmin, col);
	}
	else//HSV
	{
		if(cmax == 0.0) chroma = 0.0;
		else chroma = (cmax - cmin) / cmax;
		hue = getHueHSLandHSV(cmax, cmin, col);
	}
	return chroma;
}

uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform float threshS;
uniform float threshH1, threshH2;
uniform int space;
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	int i, j, k, l;
	float chroma, hue;
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec4 col4 = texture2D(image, texCoord);
	chroma = getChromaHue(col4.rgb, hue, space);
	vec3 col ;
	if(chroma > threshS && hue > threshH1 && hue < threshH2) col = vec3(1.0);
	else col = vec3(0.0);
	gl_FragColor = vec4(col, 1.0);		
}
