
uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform float threshold;
uniform int space;
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	int i, j, k, l;
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 col = texture2D(image, texCoord).rgb;
	float luminance, cmin, cmax;
	if(space == 0)//YCC(HSY)
    luminance = dot(col, vec3(0.299, 0.587, 0.114));
	else if(space == 1)//HSL
	{
		cmax = max(max(col.r, col.g), col.b);
		cmin = min(min(col.r, col.g), col.b);
		luminance = (cmax + cmin) / 2.0;
	}
	else//HSV
	  luminance = max(max(col.r, col.g), col.b);
	col = vec3(step(threshold, luminance));
	gl_FragColor = vec4(col, 1.0);
}


