
uniform sampler2D image1;
uniform sampler2D image2;
uniform int imgWidth, imgHeight;
uniform vec3 chroma;
uniform float delta1, delta2;
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 col1 = texture2D(image1, texCoord).rgb;
	vec3 col2 = texture2D(image2, texCoord).rgb;
	vec3 col ;
	float dist = distance(col2, chroma);
	float alpha = 1.0;
	if(dist <= delta1) alpha = 0.0;
	else if(dist >= delta2) alpha = 1.0;
	else 
	{
		if(delta1 != delta2) 
		  alpha = (dist - delta1) / (delta2 - delta1);
	}
	col = mix(col1, col2, alpha);
	gl_FragColor = vec4(col, 1.0);		
}
