
uniform sampler2D image0;
uniform sampler2D image1;
uniform int imgWidth, imgHeight;
uniform int mode;
uniform vec2 posMouse;
uniform float radius;
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 base = texture2D(image0, texCoord).rgb;
	vec3 blend = texture2D(image1, texCoord).rgb;
	vec3 col;
	if(mode == 0)//Z
		col = base + blend;
	else if(mode == 1)//Z
		col = base - blend;
	else if(mode == 2)//̐Βl
		col = abs(base - blend);
	else if(mode == 3)//riőlj
		col = max(base,blend);
	else if(mode == 4)//riŏlj
		col = min(base, blend);
	else if(mode == 5)//Z
		col = base * blend;
	else if(mode == 6)//Ă
	{
		if(max(max(blend.r, blend.g), blend.b) == 1.0) col = blend;
		else col = base / (vec3(1.0) - blend);
	}
	else if(mode == 7)//Ă
	{
		if(min(min(blend.r, blend.g), blend.b) == 0.0) col = blend;
		else col = vec3(1.0) - (vec3(1.0) - base) / blend;
	}
	else if(mode == 8)//screen
	{
		col = vec3(1.0) - (vec3(1.0) - base) * (vec3(1.0) - blend);
	}
	else if(mode == 9)//overlay
	{
	  float lum = dot(base, vec3(0.299, 0.587, 0.114));
	  if(lum <= 0.5) col = 2.0 * base * blend;
		else col = vec3(1.0) - 2.0 * (vec3(1.0) - base) * (vec3(1.0) - blend);
	}
		
	posMouse.y = float(imgHeight) - posMouse.y;
	float dist = distance(pos, posMouse);
	if(dist < radius) base = col;
	gl_FragColor = vec4(base, 1.0);		
}
