
uniform sampler2D image;
uniform sampler2D imageVoronoi;
uniform sampler2D imageRandom;
uniform int imgWidth, imgHeight;
uniform float alpha;
//uniform float alpha;
//uniform vec2 posMouse;
//uniform float radius;
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 col1 = texture2D(image, texCoord).rgb;
	vec3 col2 = texture2D(imageVoronoi, texCoord).rgb;
	vec3 col3 = texture2D(imageRandom, texCoord).rgb;

	vec4 colX = vec4(0.0);
	vec4 colY = vec4(0.0);
	vec3 col = vec3(0.0);
	//Roberts
	colX = texture2D(imageRandom, texCoord + vec2(dx, 0))
	      -texture2D(imageRandom, texCoord + vec2(0, dy));
	colY = texture2D(imageRandom, texCoord)
	      -texture2D(imageRandom, texCoord + vec2(dx, dy));

	col = (abs(colX) + abs(colY)).rgb;
	col.r = (col.r + col.g + col.b) / 3.0;

	float th = 0.01;
	if(col.r > th) col = vec3(0.2);
	else col = mix(col2, col1, alpha);

	gl_FragColor = vec4(col, 1.0);		

}
