
uniform sampler2D imageVoronoi;
uniform sampler2D imageRandom;
uniform int imgWidth, imgHeight;
uniform	float th ;

varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 col = texture2D(imageVoronoi, texCoord).rgb;

	int i, j, k, l;
	vec2 weight[9];
	vec2 offset[9];
	//offseťvZ
	for(int j = 0; j < 3; j++)
		for(int i = 0; i < 3; i++)
		{ 
			offset[i + j * 3] = vec2(float(-1 + i) * dx, float(-1 + j) * dy) ;
		}
	//Prewitt
	//X
	weight[0].x = -1.0; weight[1].x = 0.0; weight[2].x = 1.0;
	weight[3].x = -1.0; weight[4].x = 0.0; weight[5].x = 1.0;
	weight[6].x = -1.0; weight[7].x = 0.0; weight[8].x = 1.0;
	//Y
	weight[0].y = -1.0; weight[1].y =-1.0; weight[2].y =-1.0;
	weight[3].y =  0.0; weight[4].y = 0.0; weight[5].y = 0.0;
	weight[6].y =  1.0; weight[7].y = 1.0; weight[8].y = 1.0;

	vec4 colX = vec4(0.0);
	vec4 colY = vec4(0.0);
	//ݍ݉Z
	for(j = 0; j < 9; j++) 
	{
		colX += texture2D(imageRandom, texCoord + offset[j]) * weight[j].x;
		colY += texture2D(imageRandom, texCoord + offset[j]) * weight[j].y;
	}
	float dd = (abs(colX) + abs(colY)).r;
	if(dd > th) col = vec3(0.9);//

	gl_FragColor = vec4(col, 1.0);		
}
