//oil.frag

uniform sampler2D image;
uniform sampler2D imageVoronoi;
uniform sampler2D imageRandom;
uniform int imgWidth, imgHeight;
uniform	int size;//ŕpltB^TCY
uniform float alpha, delta;
uniform int nLevel;
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{

	int i, j, k, m;
	int Size = size * size;
	if(nLevel > 32) nLevel = 32;
	ivec3 hist[32];
	vec2 offset;
	ivec3 icol;
	vec3 col1, col2, col3;

	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);//ړ_W
	
	if(size == 1)
	{
		col1 = texture2D(image, texCoord).rgb;
		col2 = texture2D(imageVoronoi, texCoord ).rgb;
		col3 = texture2D(imageRandom, texCoord).rgb;
		col1 = mix(col2, col1, alpha);
		col1 *= mix(vec3(1.0), col3, delta);//_J[
		gl_FragColor = vec4(col1, 1.0) ;	
		return;
	}
	//zNA
	for(k = 0; k < nLevel; k++) hist[k] = 0;

	//ߖTfl,qXgO擾
	for(j = 0; j < size; j++)
		for(i = 0; i < size; i++)
    { 
			offset = vec2(float(-(size-1)/2 + i) * dx, float(-(size-1)/2 + j) * dy) ;

			col1 = texture2D(image, texCoord + offset).rgb;
			col2 = texture2D(imageVoronoi, texCoord + offset).rgb;
			col3 = texture2D(imageRandom, texCoord + offset).rgb;
			col1 = mix(col2, col1, alpha);
			col1 *= mix(vec3(1.0), col3, delta);//_J[
			
			//nLevelKɕϊ
			icol = ivec3(col1 * float(nLevel-1));
			//qXgO߂
			hist[icol.r].r ++;	
			hist[icol.g].g ++;	
			hist[icol.b].b ++;	
		}

	ivec3 mode = ivec3(0);
	//qXgOőƂȂ郌x
	for(k = 1; k < nLevel; k++)
	{
	  mode.r = (hist[k].r > hist[mode.r].r) ? k: mode.r;
	  mode.g = (hist[k].g > hist[mode.g].g) ? k: mode.g;
	  mode.b = (hist[k].b > hist[mode.b].b) ? k: mode.b;
	}

	//[0, 1]͈̔͂ɕϊ
	vec3 col0 = vec3(mode) / float(nLevel - 1);
	
	gl_FragColor = vec4(col0, 1.0);	
}
