uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform int dir;//̕(deg)
uniform float coef;
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
const float w = 1.0 / float(imgWidth);
const float h = 1.0 / float(imgHeight);

void main(void)
{
	int i, j, k, l;
	float weight[9];
	vec2 offset[9];
	//offseťvZ
	for(int j = 0; j < 3; j++)
		for(int i = 0; i < 3; i++)
		{ 
			offset[i+j*3] = vec2(float(-1 + i) * w, float(-1 + j) * h) ;
		}

	if(dir == 0)
	{
		weight[0] = -1.0; weight[1] = 0.0; weight[2] = 1.0;
		weight[3] = -1.0; weight[4] = 0.0; weight[5] = 1.0;
		weight[6] = -1.0; weight[7] = 0.0; weight[8] = 1.0;
	}
	else if(dir == 45)
	{
		weight[0] = -1.0; weight[1] =-1.0; weight[2] = 0.0;
		weight[3] = -1.0; weight[4] = 0.0; weight[5] = 1.0;
		weight[6] =  0.0; weight[7] = 1.0; weight[8] = 1.0;
	}
	else if(dir == 90)
	{
		weight[0] = -1.0; weight[1] =-1.0; weight[2] =-1.0;
		weight[3] =  0.0; weight[4] = 0.0; weight[5] = 0.0;
		weight[6] =  1.0; weight[7] = 1.0; weight[8] = 1.0;
	}
	else if(dir == 135)
	{
		weight[0] =  0.0; weight[1] =-1.0; weight[2] =-1.0;
		weight[3] =  1.0; weight[4] = 0.0; weight[5] =-1.0;
		weight[6] =  1.0; weight[7] = 1.0; weight[8] = 0.0;
	}
	else if(dir == 180)
	{
		weight[0] =  1.0; weight[1] = 0.0; weight[2] =-1.0;
		weight[3] =  1.0; weight[4] = 0.0; weight[5] =-1.0;
		weight[6] =  1.0; weight[7] = 0.0; weight[8] =-1.0;
	}
	else if(dir == 225)
	{
		weight[0] =  1.0; weight[1] = 1.0; weight[2] = 0.0;
		weight[3] =  1.0; weight[4] = 0.0; weight[5] =-1.0;
		weight[6] =  0.0; weight[7] =-1.0; weight[8] =-1.0;
	}
	else if(dir == 270)
	{
		weight[0] =  1.0; weight[1] = 1.0; weight[2] = 1.0;
		weight[3] =  0.0; weight[4] = 0.0; weight[5] = 0.0;
		weight[6] = -1.0; weight[7] =-1.0; weight[8] =-1.0;
	}
	else if(dir == 315)
	{
		weight[0] =  0.0; weight[1] = 1.0; weight[2] = 1.0;
		weight[3] = -1.0; weight[4] = 0.0; weight[5] = 1.0;
		weight[6] = -1.0; weight[7] =-1.0; weight[8] = 0.0;
	}
	
	vec2 texCoord = vec2(pos.x * w, pos.y * h);
	vec3 col = vec3(0.0);
	//ݍ݉Z
	for(j = 0; j < 9; j++) 
		col += texture2D(image, texCoord + offset[j]).rgb * weight[j] * coef;

	//sharpening
	col += texture2D(image, texCoord).rgb;
	gl_FragColor = vec4(vec3(col), 1.0);		
}
