
uniform sampler2D imageGen;
uniform sampler2D imageRandom;
uniform int imgWidth, imgHeight;
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);
const int size = 3;

void main(void)
{
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 col1 = texture2D(imageGen, texCoord).rgb;
	vec3 col2 = texture2D(imageRandom, texCoord).rgb;
	vec4 colX = vec4(0.0);
	vec4 colY = vec4(0.0);
	//Roberts
	colX = texture2D(imageRandom, texCoord + vec2(dx, 0))
	      -texture2D(imageRandom, texCoord + vec2(0, dy));
	colY = texture2D(imageRandom, texCoord)
	      -texture2D(imageRandom, texCoord + vec2(dx, dy));
	
	vec3 col = (abs(colX) + abs(colY)).rgb;
	col.r = (col.r + col.g + col.b) / 3.0;

	float th = 0.001;
	if(col.r > th) col = vec3(0.0);
	else if(col1.r == 1.0 && col1.g == 0.0 && col1.b == 0.0) col = col1;
	else col = col2;
	gl_FragColor = vec4(col, 1.0);
}
