

uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform int type;
uniform float eps0;
uniform vec2 posMouse;
uniform float radius;
uniform float widthRing;
uniform float gamma;
uniform int nLevelV;
uniform float threshEdge;

varying vec2 pos;//eNX`W

const float pi = 3.14159265;
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);
//ring
const vec3 colRing = vec3(0.4, 0.1, 0.2);
//Kx̍ől
const float maxV = 255.0;

void main(void)
{	
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 col = texture2D(image, texCoord).rgb;
	posMouse.y = float(imgHeight) - posMouse.y;
	float dist = distance(pos, posMouse);
	float eps = eps0;
	
	if(type >= 1)
		eps = eps0 * (1.0 - dist / radius );//ʖʋC჌Y
	if(dist > radius && dist < radius + widthRing)
	{
		gl_FragColor = vec4(colRing, 1.0);		
		return;
	}
		
	if(dist < radius)
	{
		if(type <= 1)//lens,curved mirror
		{
			pos = (pos - posMouse) * (1.0 - eps) + posMouse;
		}
		else if(type == 2)//]
		{
			vec2 pp = pos - posMouse;
			float theta = eps * pi;
			mat2 m = mat2(cos(theta), sin(theta), -sin(theta), cos(theta));
			pos = m * pp + posMouse;
		}	
	}
	
	texCoord = vec2(pos.x * dx, pos.y * dy);
	col = texture2D(image, texCoord).rgb;

	//K팸
	float vStep = maxV / float(nLevelV-1);//xXebv	
	float z = max(max(col.r, col.g), col.b) * maxV;
	float k = floor(z / vStep + 0.5);
	z = vStep * k / maxV;

	//Px
	z = pow(z, gamma);
	col = vec3(z);//vec3(step(threshold, z));

	//GbW쐬iPrewitt filterj
	int i, j, l;
  int size = 3;;
	vec2 weight[9];
	vec2 offset[9];
	//offseťvZ
	for(int j = 0; j < size; j++)
		for(int i = 0; i < size; i++)
		{ 
			offset[i + j * size] = vec2(float(-(size-1)/2 + i) * dx, float(-(size-1)/2 + j) * dy) ;
		}

	//Prewitt Operator
	//X
	weight[0].x = -1.0; weight[1].x = 0.0; weight[2].x = 1.0;
	weight[3].x = -1.0; weight[4].x = 0.0; weight[5].x = 1.0;
	weight[6].x = -1.0; weight[7].x = 0.0; weight[8].x = 1.0;
	//Y
	weight[0].y = -1.0; weight[1].y =-1.0; weight[2].y =-1.0;
	weight[3].y =  0.0; weight[4].y = 0.0; weight[5].y = 0.0;
	weight[6].y =  1.0; weight[7].y = 1.0; weight[8].y = 1.0;		

  //l
	vec2 dd   = vec2(0.0);
	vec3 colP = vec3(0.0);
	//ݍ݉Z
	for(j = 0; j < size*size; j++) 
	{
		colP = texture2D(image, texCoord + offset[j]);
	  z = max(max(colP.r, colP.g), colP.b);//HSVx
		dd += z * weight[j];
	}
	colP = length(dd);
	//] 
	colP = vec3(1.0) - colP ;
	//2l 
	if(colP.r < threshEdge)
	  colP = vec3(0.4, 0.4, 0.4);
	//Z
	col *= colP;
	if(col.r > 0.8) col = vec3(0.8, 0.8, 0.8);
	gl_FragColor = vec4(col, 1.0);		
}
