
uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform int type;
uniform float eps0;
uniform vec2 posMouse;
uniform float radius;
uniform float widthRing;
varying vec2 pos;//eNX`W

const float pi = 3.14159265;
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);
//ring
const vec3 colRing = vec3(0.4, 0.1, 0.2);

void main(void)
{	
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 col = texture2D(image, texCoord).rgb;
	posMouse.y = float(imgHeight) - posMouse.y;
	float dist = distance(pos, posMouse);
	float eps = eps0;
	
	if(type >= 1)
		eps = eps0 * (1.0 - dist / radius );//ʖʋC჌Y

	if(dist > radius + widthRing)
	{
		gl_FragColor = vec4(col, 1.0);		
		return;
	}
	if(dist > radius && dist < radius + widthRing)
	{
		gl_FragColor = vec4(colRing, 1.0);		
		return;
	}
		
	if(type <= 1)//lens,curved mirror
	{
		pos = (pos - posMouse) * (1.0 - eps) + posMouse;
	}
	else if(type == 2)//]
	{
		vec2 pp = pos - posMouse;
		float theta = eps * pi;
		mat2 m = mat2(cos(theta), sin(theta), -sin(theta), cos(theta));
		pos = m * pp + posMouse;
  }	
	
	texCoord = vec2(pos.x * dx, pos.y * dy);
	col = texture2D(image, texCoord).rgb;

	gl_FragColor = vec4(col, 1.0);		
}
