

uniform sampler2D image;
uniform sampler2D imageVoronoi;
//uniform int imgWidth, imgHeight;
uniform float alpha;
//eNX`WԂɂfʒu̒P
//float dx = 1.0 / float(imgWidth);
//float dy = 1.0 / float(imgHeight);
//const int size = 3;//EotB^̃TCY

varying vec3 P;
varying vec3 N;
varying vec2 texCoord;


void main(void)
{
  vec3 L = normalize(gl_LightSource[0].position.xyz - P);
  N = normalize(N);
  
  vec4 ambient = gl_FrontLightProduct[0].ambient;
  float dotNL = dot(N, L);
  vec4 diffuse = gl_FrontLightProduct[0].diffuse * max(0.0, dotNL);
	vec3 V = normalize(-P);
	vec3 H = normalize(L + V);
	float powNH = pow(max(dot(N, H), 0.0), gl_FrontMaterial.shininess);
	if(dotNL <= 0.0) powNH = 0.0;
	vec4 specular = gl_FrontLightProduct[0].specular * powNH;
  //eNX`̐F
	vec3 col1 = texture2D(image, texCoord).rgb;
	vec3 col2 = texture2D(imageVoronoi, texCoord).rgb;

	vec3 col = mix(col2, col1, alpha);
	vec4 texColor = vec4(col, 1.0);
	//MODULATE mode
  gl_FragColor = (ambient + diffuse) * texColor + specular;
}
