//metal.frag
uniform sampler2D image;
uniform sampler2D imageHeight;
uniform float alpha;
uniform float rough;//eW
uniform int mode;//\[h

varying vec3 P;
varying vec3 N;
varying vec2 texCoord;

void main(void)
{
  vec3 L = normalize(gl_LightSource[0].position.xyz - P);
  N = normalize(N);
	if(texture2D(imageHeight, texCoord).r == 0.0) rough = 1000.0;

  vec4 ambient = gl_FrontLightProduct[0].ambient;
  float dotNL = dot(N, L);
  vec4 diffuse = gl_FrontLightProduct[0].diffuse * max(0.0, dotNL);
	vec4 specular = vec4(0.0);
  if(dotNL > 0.0)
  {//Cook-Torrance ˃f
		vec3 V = normalize(-P);
		vec3 H = normalize(L + V);
		float dotNH = max(dot(N, H), 0.0);
		float d = dotNH * dotNH;
		float b = d * d;
		float c = (d - 1.0) / (rough * rough * d);
		float dotNV = dot(N, V);
		//z֐
		float D = min(1.0, exp(c) /(4.0 * 3.14 * rough * rough * b));	
		//􉽌W
		float dotVH = dot(V, H);
		float Gout = 2.0 * dotNH * dotNV / dotVH;
		float Gin = 2.0 * dotNH * dotNL / dotVH;
		float G = min(1.0, min(Gout, Gin));
		//tlWiˌWj
		vec3 F0 = gl_FrontLightProduct[0].specular.rgb;
		//Schlick̋ߎ
		vec3 F = F0 + (vec3(1.0) - F0) * pow(1.0 - dotVH, 5.0);
		specular.rgb = D * F * G / dotNV;
	}
	//texture
	vec4 texColor = texture2D(image, texCoord);
	specular *= texture2D(imageHeight, texCoord).r;
	//
	if(mode == 0)//[h
		gl_FragColor = mix(ambient + diffuse, texColor, alpha) + specular;
  else//ϒ[h
		gl_FragColor = (ambient + diffuse) * texColor + specular;
}
