
varying vec3 P;//ʒuxNg
varying vec3 N;//@xNg
uniform sampler2D image;
varying vec2 texCoord;

void main(void)
{
  vec3 L = normalize(gl_LightSource[0].position.xyz - P);
  N = normalize(N);
 
  vec4 ambient = gl_FrontLightProduct[0].ambient;
  float dotNL = max(dot(N, L), 0.0);	
	vec4 diffuse = gl_FrontLightProduct[0].diffuse * dotNL;
	vec3 V = normalize(-P);
	vec3 H = normalize(L + V);
	float powNH = pow(max(dot(N, H), 0.0), gl_FrontMaterial.shininess);
	if(dotNL <= 0.0) powNH = 0.0;
	vec4 specular = gl_FrontLightProduct[0].specular * powNH;
	
  //eNX`̐F
  vec3 texColor = texture2D(image, texCoord).rgb;
  if(texColor.r < 0.001) discard;//

  float dotNV = max(dot(N, V), 0.0);
  vec3 spec0 = vec3(0.0);
  vec3 spec1 = vec3(1.0);
	vec3 col = ambient.rgb;
	if(dotNV > 0.05)
	{
		if(dotNL > 0.7) col += diffuse.rgb;
		else if(dotNL > 0.2) col += diffuse.rgb * 0.5;
		col += (powNH > 0.5) ? spec1: spec0;//specular
	}
	else col = vec3(0.0, 0.0, 0.3);//edge
	
	gl_FragColor = vec4(col, 1.0);
}