
uniform float edgeWidth;
varying vec3 P;//ʒuxNg
varying vec3 N;//@xNg

void main(void)
{
  vec3 L = normalize(gl_LightSource[0].position.xyz - P);
  N = normalize(N);
 
  vec4 ambient = gl_FrontLightProduct[0].ambient;
  float dotNL = max(dot(N, L), 0.0);
	vec4 diffuse = gl_FrontLightProduct[0].diffuse * dotNL;
	vec3 V = normalize(-P);
	vec3 H = normalize(L + V);
	float powNH = pow(max(dot(N, H), 0.0), gl_FrontMaterial.shininess);
	if(dotNL <= 0.0) powNH = 0.0;
  float dotNV = max(dot(N, V), 0.0);

	vec4 col = ambient;
	if(dotNV > edgeWidth)
	{
		if(dotNL >= 0.7) col += diffuse;
		else if(dotNL >= 0.2) col += diffuse * 0.5;
		else col += vec4(vec3(0.0), 1.0);
		col += (powNH > 0.5) ? 1.0: 0.0;//specular
	}
	else col = vec4(0.1, 0.1, 0.1, 1.0);//edge
	gl_FragColor = col;
}