const float pi = 3.14159265;
float getWave(float freq, float lambda, float r, float t)
{
    float phase = 2.0 * pi * ( freq * t - r / lambda);
    float a = 0.0;
    
    if(phase >= 0.0) a = sin(phase) / (0.1 + sqrt(r));
    return( a );
}
float makeWaveCircle(int numWave, float amp, float freq, float lambda, vec2 pos, float t)
{
  int i, j, k;
  float r;
  vec2 source[3];//~`g̒S

  //g
  source[0].x = 0.5; source[0].y = 0.5;
  source[1].x = 0.1; source[1].y = 0.1;
  source[2].x = 0.9; source[2].y = 0.1;

  float wave = 0.0;

  for(k = 0; k < numWave; k++)
  {
      r = length(pos - source[k]);
      wave += amp * getWave(freq, lambda, r, t);
  }
  return wave;
}
//--------------------------------------------------------
uniform int numWave;
uniform float freq;
uniform float lambda;
uniform float amp;
uniform float time;
uniform int imgWidth, imgHeight;
varying vec3 P;
varying vec3 N;
varying vec2 texCoord;
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	//eNX`W
	texCoord = gl_Vertex.xy + vec2(0.5, 0.5);
	//gl
	float wave = makeWaveCircle(numWave, amp, freq, lambda, texCoord, time);
	//s
	vec2 offset = vec2(-dx, 0.0);
	float wave1 = makeWaveCircle(numWave, amp, freq, lambda, texCoord + offset, time);
	offset = vec2(dx, 0.0);
	float deltaS = wave - wave1;
	//t
	offset = vec2(0.0, -dy);
	wave1 = makeWaveCircle(numWave, amp, freq, lambda, texCoord + offset, time);
	offset = vec2(0.0, dy);
	float deltaT = wave - wave1;
	//s,tW̒PʃxNg
	vec3 As = vec3(1.0, 0.0, 0.0);//x
	vec3 At = vec3(0.0, 1.0, 0.0);//y
  
  gl_Vertex.z += wave * 0.05;
  P = vec3(gl_ModelViewMatrix * gl_Vertex);
  //gl_Normal.x += wave;
  //gl_Normal.y += wave;
  N = normalize(gl_NormalMatrix * gl_Normal).xyz;
  //V@xNg
  N -= As * deltaS + At * deltaT;
  
  gl_Position = ftransform();
}
