
const float pi = 3.14159265;

float getWave(float freq, float lambda, float r, float t)
{
    float phase = 2.0 * pi * ( freq * t - r / lambda);
    float a = 0.0;
    
    if(phase >= 0.0) a = sin(phase) / (0.1 + sqrt(r));
    return( a );
}

float makeWaveCircle(int numWave, float amp, float freq, float lambda, vec2 pos, float t)
{
  int i, j, k;
  float r;
  vec2 source[3];//~`g̒S

  //g
  source[0].x = 0.5; source[0].y = 0.5;
  source[1].x = 0.1; source[1].y = 0.1;
  source[2].x = 0.9; source[2].y = 0.1;

  float wave = 0.0;

  for(k = 0; k < numWave; k++)
  {
      r = length(pos - source[k]);
      wave += amp * getWave(freq, lambda, r, t);
  }
  return wave;
}

uniform int numWave;
uniform float freq;
uniform float lambda;
uniform float amp;
uniform float time;
uniform float nRatio;
uniform mat4 ViewTranspose;//r[ϊ̃fr[s(]uj
varying vec3 P;
varying vec3 N;
varying vec4 Refract;

void main(void)
{
//	vec2 pos = gl_Vertex.xy + vec2(0.5, 0.5);
//	float wave = makeWaveCircle(numWave, amp, freq, lambda, pos, time);
	//
	float dx = 0.01;
	float dy = 0.01;
	//g߂ʒu
	vec2 pos = gl_Vertex.xy + vec2(0.5, 0.5);
	//gl
	float wave = makeWaveCircle(numWave, amp, freq, lambda, pos, time);
	//s
	vec2 offset = vec2(-dx, 0.0);
	float wave1 = makeWaveCircle(numWave, amp, freq, lambda, pos + offset, time);
	offset = vec2(dx, 0.0);
	float deltaS = wave - wave1;
	//t
	offset = vec2(0.0, -dy);
	wave1 = makeWaveCircle(numWave, amp, freq, lambda, pos + offset, time);
	offset = vec2(0.0, dy);
	float deltaT = wave - wave1;
	//s,tW̒PʃxNg
	vec3 As = vec3(1.0, 0.0, 0.0);//x
	vec3 At = vec3(0.0, 1.0, 0.0);//y

  gl_Vertex.z += wave * 0.5;
  P = gl_ModelViewMatrix * gl_Vertex;
  N = normalize(gl_NormalMatrix * gl_Normal);
  //V@xNg
  N -= As * deltaS + At * deltaT;
	//()xNg
  vec3 incident = normalize(P);
  //nRatio += wave;
  //܃xNg
	vec3 refract0 = refract(incident, N, 1.0 / nRatio);
	//܃xNgɂeNX`W
  Refract = ViewTranspose * vec4(refract0, 1.0);
//  Refract = gl_TextureMatrix[0] * vec4(refract0, 1.0);
  gl_Position = ftransform();
}
