//#include <math.h>
#include <stdio.h>
//#include "../../spline.h"
//#include "../../myMath3.h"

#define M_PI 3.14159265358979323846

//@vZ[`
void calcNormal(float* p1,float* p2,float* p3,float* nn)
{
	double mag;
	float a[3], b[3];
	int k, k1, k2;


	for(k = 0; k < 3; k++)
	{
		a[k] = p2[k] - p1[k];
		b[k] = p3[k] - p2[k];
	}

	for(k = 0; k < 3; k++)
	{
		k1 = k + 1; k2 = k + 2;
		if(k1 >= 3) k1 = k1 -3;
		if(k2 >= 3) k2 = k2 -3;
		nn[k] = a[k1]*b[k2] - a[k2]*b[k1];
	}
	//normalize
	mag = nn[0] * nn[0] + nn[1] * nn[1] + nn[2] * nn[2];
	for(k = 0; k < 3; k++) nn[k] = nn[k] / mag; 
}

//------------------------------------------------------------------------------
void drawPlateZ(float s)//x-y
{//ʂ̖@
	float p[4][3] = 
	{ { s/2.0,-s/2.0, 0.0}, { s/2.0, s/2.0, 0.0}, {-s/2.0, s/2.0, 0.0}, 
	  {-s/2.0,-s/2.0, 0.0}};

	glBegin(GL_QUADS);
		glNormal3f(0.0, 0.0, 1.0); //z̖@
		glVertex3fv(p[0]);
		glVertex3fv(p[1]);
		glVertex3fv(p[2]);
		glVertex3fv(p[3]);
	glEnd();
}
//------------------------------------------------------------------------------
void drawPlateY(float s)//x-z
{//ʂ̖@y
	float p[4][3] = 
	{ { s/2.0, 0.0, s/2.0}, { s/2.0, 0.0,-s/2.0}, {-s/2.0, 0.0,-s/2.0}, {-s/2.0, 0.0, s/2.0}};

	glBegin(GL_QUADS);
		glNormal3f(0.0, 1.0, 0.0); //y̖@
		glVertex3fv(p[0]);
		glVertex3fv(p[1]);
		glVertex3fv(p[2]);
		glVertex3fv(p[3]);
	glEnd();
}

//-----------------------------------------------------------------------

void drawCube(float s)
{
	float p[8][3] = 
	{ {0.5*s,0.5*s,0.5*s}, {-0.5*s,0.5*s,0.5*s}, {-0.5*s,-0.5*s,0.5*s}, 
	  {0.5*s,-0.5*s,0.5*s},{0.5*s,0.5*s,-0.5*s}, {-0.5*s,0.5*s,-0.5*s},
	  {-0.5*s,-0.5*s,0-0.5*s}, {0.5*s,-0.5*s,-0.5*s}
	};

	glBegin(GL_QUADS);
		glNormal3f(0.0f,0.0f,1.0f); //z
		glVertex3fv(p[0]); glVertex3fv(p[1]);
		glVertex3fv(p[2]); glVertex3fv(p[3]);

		glNormal3f(1.0f,0.0f,0.0f); //x(ʁj
		glVertex3fv(p[0]); glVertex3fv(p[3]);
		glVertex3fv(p[7]); glVertex3fv(p[4]);

		glNormal3f(0.0f,1.0f,0.0f); //y
		glVertex3fv(p[0]); glVertex3fv(p[4]);
		glVertex3fv(p[5]); glVertex3fv(p[1]);

	 	glNormal3f(-1.0f,0.0f,0.0f); //-x
		glVertex3fv(p[1]); glVertex3fv(p[5]);
		glVertex3fv(p[6]); glVertex3fv(p[2]);

		glNormal3f(0.0f,-1.0f,0.0f); //-y
		glVertex3fv(p[2]); glVertex3fv(p[6]);
		glVertex3fv(p[7]); glVertex3fv(p[3]);

		glNormal3f(0.0f,0.0f,-1.0f); //-z
		glVertex3fv(p[4]); glVertex3fv(p[7]);
		glVertex3fv(p[6]); glVertex3fv(p[5]);
	glEnd();
}
//-----------------------------------------------------------------

void drawGridPlate(float sizeX, float sizeY, int nSliceX, int nSliceY)
{//xyʁCS͌_
	int i, j;
	//double ;
	float p[2][3];
	float pitchX = sizeX / (float)nSliceX;
	float pitchY = sizeY / (float)nSliceY;

	for(j = 0; j < nSliceY; j++)
	{
		//_zW
		p[0][2] = 0.0;
		p[1][2] = 0.0;

		glBegin(GL_QUAD_STRIP);
		for(i = 0; i <= nSliceX; i++)
		{
			p[0][0] = (float)i * pitchX - sizeX / 2.0;//xW
			p[0][1] = (float)j * pitchY - sizeY / 2.0;//yW
			p[1][0] = (float)i * pitchX - sizeX / 2.0;//xW
			p[1][1] = (float)(j+1) * pitchY - sizeY / 2.0;//yW

			glNormal3f(0.0, 0.0, 1.0);//@xNg
			glVertex3fv(p[0]);//_W
			glVertex3fv(p[1]);//_W			
		}
		glEnd();
	}
}

//-----------------------------------------------------------------------
void drawSphere(float radius, int nSlice, int nStack)
{
	int i, j;
	double r0, r1, th0, th1, phi;
	double p[2][3];

	for(j = 0; j < nStack; j++)
	{
		//j=0͖kɓ_(x=0, y=0, z=radius)
		//Vp
		th0 = M_PI * (double)j / (double)nStack;
		th1 = M_PI * (double)(j+1) / (double)nStack;
		//x-yʂɓea
		r0 = radius * sin(th0);
		r1 = radius * sin(th1);
		//_zW
		p[0][2] = radius * cos(th0);
		p[1][2] = radius * cos(th1);

		glBegin(GL_QUAD_STRIP);
		for(i = 0; i <= nSlice; i++)
		{
			phi = 2.0 * M_PI * (double)i / (double)nSlice;
			//_xyW(i=0object݂ĉE[) 
			p[0][0] =   r0 * sin(phi);//xW
			p[0][1] = - r0 * cos(phi);//yW
			p[1][0] =   r1 * sin(phi);//xW
			p[1][1] = - r1 * cos(phi);//yW

			glNormal3dv(p[0]);//@xNg
			glVertex3dv(p[0]);//_W

			glNormal3dv(p[1]);//@xNg
			glVertex3dv(p[1]);//_W			
		}
		glEnd();
	}
}
//----------------------------------------------------------------------
void drawCylinder(float rBottom, float rTop, float height, int nSlice, int nStack)
{ //z
	//~(rBottom=rTop))A~A~(rTop = 0.0)
	//rBottom:ꔼa, rTop:ꔼa
	//nSlice--xyfʕ
	//nStack---
	//̂̒S͉Ə̒

	int i, j;
	double x, y, z, z0, z1;
	double theta;
	double theta0 = 2.0*M_PI/(double)nSlice;
	//(Top)
	glBegin(GL_TRIANGLE_FAN);
	glNormal3f(0.0, 0.0, 1.0);
	glVertex3f(0.0, 0.0, height/2.0);
	for(i = 0; i <= nSlice; i++) 
	{ 
		theta = theta0 * (double)i;
		x = (float)(rTop * cos(theta)); //x
		y = (float)(rTop * sin(theta)); //
		z = height/2.0;
		glVertex3f(x, y, z);
	}
	glEnd();

	//(Bottom)
	glBegin(GL_TRIANGLE_FAN);
	glNormal3f(0.0, 0.0, -1.0);
	glVertex3f(0.0, 0.0, -height/2.0);
	for(i = 0; i <= nSlice; i++) 
	{ 
		theta = theta0 * (double)(nSlice - i);
		x = (float)(rBottom * cos(theta)); //x
		y = (float)(rBottom * sin(theta)); //
		z = -height/2.0;
		glVertex3f(x, y, z);
	}
	glEnd();

	double s, t0, t1, r0, r1, phi;
	double p[2][3], n[3];

	double rr = rBottom - rTop;
	double nz = rr / sqrt(rr*rr + height*height);
  double nxy = sqrt(1.0 - nz * nz);
	//
	for(j = 0; j < nStack; j++)
	{
		//j=0͏(x=0, y=0, z=height/2)
		//2tW
		t0 = (double)j / (double)nStack;
		t1 = (double)(j+1) / (double)nStack;
		//ʂ̍
		z0 = height * (1.0 - t0);
		z1 = height * (1.0 - t1);
		//a
		r0 = rBottom + (rTop - rBottom) * z0 / height;
		r1 = rBottom + (rTop - rBottom) * z1 / height;

		//_zW
		p[0][2] = z0 - height / 2.0;
		p[1][2] = z1 - height / 2.0;

		glBegin(GL_QUAD_STRIP);
		for(i = 0; i <= nSlice; i++)
		{
			//sW
			s = (double)i / (double)nSlice;
			phi = 2.0 * M_PI * s + M_PI / 6.0;
			//_xyW
			p[0][0] = r0 * cos(phi);//xW
			p[0][1] = r0 * sin(phi);//yW
			p[1][0] = r1 * cos(phi);//xW
			p[1][1] = r1 * sin(phi);//yW
			//@xNg
			n[0] = nxy * cos(phi);
			n[1] = nxy * sin(phi);
			n[2] = nz;

			glNormal3dv(n);//@xNg
			glVertex3dv(p[0]);//_W
			glVertex3dv(p[1]);//_W
		}
		glEnd();
	}
}
//----------------------------------------------------------------------
void drawCylinderY(float rBottom, float rTop, float height, int nSlice, int nStack)
{ //Y
	//~(rBottom=rTop))A~A~(rTop = 0.0)
	//rBottom:ꔼa, rTop:ꔼa
	//nSlice--ZXfʕ
	//nStack---Y
	//̂̒S͉Ə̒

	int i, j;
	double Z, X, Y, Y0, Y1;
	double theta;
	double theta0 = 2.0*M_PI/(double)nSlice;
	//(Top)
	glBegin(GL_TRIANGLE_FAN);
	glNormal3f(0.0, 1.0, 0.0);
	glVertex3f(0.0, height/2.0, 0.0);
	for(i = 0; i <= nSlice; i++) 
	{ 
		theta = theta0 * (double)i;
		Z = (float)(rTop * cos(theta)); //Z
		X = (float)(rTop * sin(theta)); //X
		Y = height/2.0;
		glVertex3f(X, Y, Z);
	}
	glEnd();

	//(Bottom)
	glBegin(GL_TRIANGLE_FAN);
	glNormal3f(0.0, -1.0, 0.0);
	glVertex3f(0.0, -height/2.0, 0.0);
	for(i = 0; i <= nSlice; i++) 
	{ 
		theta = theta0 * (double)(nSlice - i);
		Z = (float)(rBottom * cos(theta)); //Z
		X = (float)(rBottom * sin(theta)); //
		Y = -height/2.0;
		glVertex3f(X, Y, Z);
	}
	glEnd();

	double s, t0, t1, r0, r1, phi;
	double p[2][3], n[3];

	double rr = rBottom - rTop;
	double nY = rr / sqrt(rr*rr + height*height);
  double nZX = sqrt(1.0 - nY * nY);
	//
	for(j = 0; j < nStack; j++)
	{
		//j=0͏(Z=0, X=0, Y=height/2)
		//2tW
		t0 = (double)j / (double)nStack;
		t1 = (double)(j+1) / (double)nStack;
		//ʂ̍
		Y0 = height * (1.0 - t0);
		Y1 = height * (1.0 - t1);
		//a
		r0 = rBottom + (rTop - rBottom) * Y0 / height;
		r1 = rBottom + (rTop - rBottom) * Y1 / height;

		//_YW
		p[0][1] = Y0 - height / 2.0;
		p[1][1] = Y1 - height / 2.0;

		glBegin(GL_QUAD_STRIP);
		for(i = 0; i <= nSlice; i++)
		{
			//sW
			s = (double)i / (double)nSlice;
			phi = 2.0 * M_PI * s + M_PI / 6.0;
			//_ZXW
			p[0][2] = r0 * cos(phi);//ZW
			p[0][0] = r0 * sin(phi);//XW
			p[1][2] = r1 * cos(phi);//ZW
			p[1][0] = r1 * sin(phi);//XW
			//@xNg
			n[2] = nZX * cos(phi);
			n[0] = nZX * sin(phi);
			n[1] = nY;

			glNormal3dv(n);//@xNg
			glVertex3dv(p[0]);//_W
			glVertex3dv(p[1]);//_W
		}
		glEnd();
	}
}

//-----------------------------------------------------------------------------------------

void drawTorus(float radius1, float radius2, int nSide, int nRing)
{	
	//radius1:~fʔa
	//radius2:~̒Sa
	//nSide:~fʂɂ\ʕ_
	//nRing:~̕
	if(radius1 > radius2) { printf("radius1 < radius2ƂĂ \n "); return;}

	int i, j;
	double rr, zz;
	double phi0, phi1, theta;
	double p[2][3];

	for(i = 0; i < nRing; i++)
	{
		//i=0͊{f(x=radius2𒆐SƂ~, y=0j
		phi0 = 2.0 * M_PI * (double)i / (double)nRing;
		phi1 = 2.0 * M_PI * (double)(i+1) / (double)nRing;

		glBegin(GL_QUAD_STRIP);
		for(j = 0; j <= nSide; j++)
		{
			theta = M_PI - 2.0 * M_PI * (double)j / (double)nSide;
			rr = radius2 + radius1 * cos(theta);//z̋
			zz = radius1 * sin(theta);
			//_xyzW(j=0xy)
			p[0][0] = rr * cos(phi0);//xW
			p[0][1] = rr * sin(phi0);//y
			p[0][2] = zz;            //z
			p[1][0] = rr * cos(phi1);//xW
			p[1][1] = rr * sin(phi1);//y
			p[1][2] = zz;            //z      

			glNormal3d(cos(theta)*cos(phi0),cos(theta)*sin(phi0),sin(theta));
			glVertex3dv(p[0]);//_W

			glNormal3d(cos(theta)*cos(phi1),cos(theta)*sin(phi1),sin(theta));
			glVertex3dv(p[1]);//_W
		}
		glEnd();
	}
}
//-----------------------------------------------------------------
void drawSuper(float r, int nSlice, int nStack, double eps1, double eps2)
{
	//㉺̒S_
	int i,j,ip,im,np,npL,npR,npU,npD,k1,k2;
	double ct,theta,phi,z,cc;
	float a[31][31], b[31][31], c[31][31];
	float n1[3], n2[3], n3[3], n4[3];
	float pd[31*31][3];

	if(nSlice > 30) nSlice = 30;
	if(nStack > 30) nStack = 30;

	for(j = 0 ;j <= nStack;j++)
	{
		theta = (M_PI/(double)nStack) * ((double)nStack / 2.0 - (double)j);
		                //thetax-yʂ̕ΊpƂȂĂ

		if(theta >= 0.0) //㔼
		{
			if(theta == 0.0) z = 0.0;//pow(a,b)aa<=0.0ŃG[
			else z = pow(sin(fabs(theta)),eps1);//z
		}
		else  //        
		{
			z = - pow(sin(fabs(theta)), eps1);
		}
		for (i = 0 ;i <= nSlice / 2;i++)
		{
			k1 = nSlice * j + i;//object猩č
			k2 = nSlice * j + nSlice - i;//E
			phi = 2.0 * M_PI * (double)i/(double)nSlice;
			ct = cos(phi);
			if( ct == 0.0 ) cc = 0.0;
			else if (ct > 0) { cc = pow(ct, eps2);}
			else         { cc = -pow(fabs(ct),eps2); }
			if(j == 0 || j == nStack) 
			{
				pd[k1][0] = 0.0f;
				pd[k1][1] = 0.0f;
			}

			else 
			{
				pd[k1][0] = r * (float)(pow(cos(theta),eps1)*cc);
				if(sin(phi) == 0.0) pd[k1][1] = 0.0f;
				else pd[k1][1] = r * (float)(pow(cos(theta),eps1)*pow(fabs(sin(phi)),eps2));
			}
			if(i == 0) k2 = k1;
			pd[k2][0] = pd[k1][0];
			pd[k2][1] = -pd[k1][1];
			pd[k1][2] = r * (float)z;
			pd[k2][2] = r * (float)z;
		}
	}

	//ʂ̖@
	for(i = 0;i < nSlice;i++)
	{
		ip = i+1;
		if(ip == nSlice) ip = 0;
		im = i-1;
		if(i == 0) im = nSlice-1;

		//^(Top)
		a[i][0] = 0.0f; b[i][0] = 0.0f; c[i][0] = 1.0f;
		//^iBottom)
		a[i][nStack] = 0.0f; b[i][nStack] = 0.0f; c[i][nStack] = -1.0f;

		for(j=1;j<nStack;j++)//ׂ荇4̎Op`̖@xNg𕽋ω
		{
			np = j*nSlice+i;//ړ_
			npL = j*nSlice+im;//
			npR = j*nSlice+ip;//E
			npU = np-nSlice;//
			npD = np+nSlice;//
			if(j == 1) 
			{
				n1[0]=0.0f; n1[1]=0.0f; n1[2]=1.0f;//Top
				n2[0]=0.0f; n2[1]=0.0f; n2[2]=1.0f;//Top
				calcNormal(pd[np],pd[npL],pd[npD],n3);//O猩č
				calcNormal(pd[np],pd[npD],pd[npR],n4);//E
			}
			if(j == nStack-1)
			{
				calcNormal(pd[np],pd[npU],pd[npL],n1);//O猩č
				calcNormal(pd[np],pd[npR],pd[npU],n2);//E
				n3[0]=0.0f; n3[1]=0.0f; n3[2]=-1.0f;//Bottom
				n4[0]=0.0f; n4[1]=0.0f; n4[2]=-1.0f;//Bottom
			}
			else 
			{
				calcNormal(pd[np],pd[npU],pd[npL],n1);//O猩č
				calcNormal(pd[np],pd[npR],pd[npU],n2);//E
				calcNormal(pd[np],pd[npL],pd[npD],n3);//O猩č
				calcNormal(pd[np],pd[npD],pd[npR],n4);//E
			}
			a[i][j] = (float)((n1[0]+n2[0]+n3[0]+n4[0])/4.0f);//
			b[i][j] = (float)((n1[1]+n2[1]+n3[1]+n4[1])/4.0f);//
			c[i][j] = (float)((n1[2]+n2[2]+n3[2]+n4[2])/4.0f);//
		}
	}

	glBegin(GL_QUADS);
	for(i = 0;i < nSlice;i++)
	{
		ip = i + 1;
		if(ip == nSlice) ip = 0;
		for(j = 0;j < nStack; j++)
		{
			glNormal3f(a[i][j],b[i][j],c[i][j]);
			glVertex3fv(pd[i+j*nSlice]);
			glNormal3f(a[i][j+1],b[i][j+1],c[i][j+1]);
			glVertex3fv(pd[i+(j+1)*nSlice]);
			glNormal3f(a[ip][j+1],b[ip][j+1],c[ip][j+1]);
			glVertex3fv(pd[ip+(j+1)*nSlice]);
			glNormal3f(a[ip][j],b[ip][j],c[ip][j]);
			glVertex3fv(pd[ip +j*nSlice]);
		}
	}
	glEnd();
}

//-----------------------------------------------------------------------------
//lp`̃bVix-y,S_j
//C̕Œ
void drawElevation(int Nx, int Ny, float sizeX, float sizeY, int sideFlag, float* data)
{
	//Ŝ̕,sizeX, sizeY
	//sideFlag = 0:ʕ\
	//sideFlag = 1:ʕ\

	const int NMAX = 130;
	int i, j;
	float p[NMAX][NMAX][3]; //_W
	float a[NMAX][NMAX], b[NMAX][NMAX], c[NMAX][NMAX];//_̖@
	float pitchX, pitchY;
	float n1[3], n2[3], n3[3], n4[3];

	if(Nx > NMAX) printf("NxNMAX𒴂Ă܂(drawElevation1) \n");
	if(Ny > NMAX) printf("NyNMAX𒴂Ă܂(drawElevation1) \n");

	//Z̃TCY
	pitchX = sizeX / (float)Nx;
	pitchY = sizeY / (float)Ny;

	//e_̍W
	for(j = 0; j <= Ny; j++){
		for(i = 0; i <= Nx; i++){
			p[i][j][0] = (float)(i - Nx / 2) * pitchX;
			p[i][j][1] = (float)(j - Ny / 2) * pitchY;
			p[i][j][2] = data[j * (Nx+1) + i];
		}
	}
	
	//@
	for(i = 0;i <= Nx;i++)
		for(j = 0;j <= Ny;j++)
		{			
			if(j == 0 )
			{
				if(i == 0) 
				{
					calcNormal(p[0][0],p[1][0],p[0][1],n1);
					a[i][j] = n1[0]; b[i][j] = n1[1]; c[i][j] = n1[2]; }
				else if(i == Nx) 
				{
					calcNormal(p[Nx-1][0],p[Nx][0],p[Nx][1],n1);
					a[i][j] = n1[0]; b[i][j] = n1[1]; c[i][j] = n1[2]; }
				else 
				{
					calcNormal(p[i][0],p[i][1],p[i-1][0],n1);//
					calcNormal(p[i][0],p[i+1][0],p[i][1],n2);//E
					a[i][j] = (n1[0]+n2[0])/2.0f;
					b[i][j] = (n1[1]+n2[1])/2.0f;
					c[i][j] = (n1[2]+n2[2])/2.0f; }
			}
			else if(j == Ny)
			{
				if(i == 0) 
				{
					calcNormal(p[0][Ny],p[0][Ny-1],p[1][Ny],n1);
					a[i][j] = n1[0]; b[i][j] = n1[1]; c[i][j] = n1[2]; }
				else if(i == Nx) 
				{
					calcNormal(p[Nx][Ny],p[Nx-1][Ny],p[Nx][Ny-1],n1);
					a[i][j] = n1[0]; b[i][j] = n1[1]; c[i][j] = n1[2]; }
				else 
				{
					calcNormal(p[i][Ny],p[i-1][Ny],p[i][Ny-1],n1);//
					calcNormal(p[i][Ny],p[i][Ny-1],p[i+1][Ny],n2);//E
					a[i][j] = (n1[0]+n2[0])/2.0f;
					b[i][j] = (n1[1]+n2[1])/2.0f;
					c[i][j] = (n1[2]+n2[2])/2.0f; }
			}
			else
			{
				if(i == 0) 
				{
					calcNormal(p[0][j],p[1][j],p[0][j+1],n1);//
					calcNormal(p[0][j],p[0][j-1],p[0][1],n2);//
					a[i][j] = (n1[0]+n2[0])/2.0f;
					b[i][j] = (n1[1]+n2[1])/2.0f;
					c[i][j] = (n1[2]+n2[2])/2.0f; }
				else if(i == Nx) 
				{
					calcNormal(p[Nx][j],p[Nx][j+1],p[Nx-1][j],n1);//
					calcNormal(p[Nx][j],p[Nx-1][j],p[Nx][j-1],n2);//
					a[i][j] = (n1[0]+n2[0])/2.0f;
					b[i][j] = (n1[1]+n2[1])/2.0f;
					c[i][j] = (n1[2]+n2[2])/2.0f; }
				else 
				{//㉺ES̎Op`̕
					calcNormal(p[i][j],p[i][j+1],p[i-1][j],n1);//
					calcNormal(p[i][j],p[i+1][j],p[i][j+1],n2);//E
					calcNormal(p[i][j],p[i-1][j],p[i][j-1],n3);//
					calcNormal(p[i][j],p[i][j-1],p[i+1][j],n4);//E
					a[i][j] = (n1[0]+n2[0]+n3[0]+n4[0])/4.0f;
					b[i][j] = (n1[1]+n2[1]+n3[1]+n4[1])/4.0f;
					c[i][j] = (n1[2]+n2[2]+n3[2]+n4[2])/4.0f; }
			}
		}

//	int nC;
	//Op`Ŗʂ`
	glBegin(GL_TRIANGLES);
	for(j = 0;j < Ny;j++)
		for(i = 0;i < Nx;i++)
		{
			//̎Op`
			//e_̖@,øW,_W^B
			glNormal3f(a[i][j],b[i][j],c[i][j]);//@
			glVertex3fv(p[i][j]);//غ݂̒_WiȉJԂj
			glNormal3f(a[i+1][j],b[i+1][j],c[i+1][j]);
			glVertex3fv(p[i+1][j]);
			glNormal3f(a[i][j+1],b[i][j+1],c[i][j+1]);
			glVertex3fv(p[i][j+1]);
			//E̎Op`
			glNormal3f(a[i+1][j],b[i+1][j],c[i+1][j]);
			glVertex3fv(p[i+1][j]);
			glNormal3f(a[i+1][j+1],b[i+1][j+1],c[i+1][j+1]);
			glVertex3fv(p[i+1][j+1]);
			glNormal3f(a[i][j+1],b[i][j+1],c[i][j+1]);
			glVertex3fv(p[i][j+1]);
		}
	glEnd();

	if(sideFlag == 1)//ʕ`
	{
		glBegin(GL_QUADS);
		//+xii=Nx)
		glNormal3f(1.0, 0.0, 0.0);
		for(j = 0; j < Ny; j++)
		{
			glVertex3f(p[Nx][j][0], p[Nx][j][1], 0.0f);
			glVertex3f(p[Nx][j+1][0], p[Nx][j+1][1], 0.0f);
			glVertex3f(p[Nx][j+1][0], p[Nx][j+1][1], p[Nx][j+1][2]);
			glVertex3f(p[Nx][j][0], p[Nx][j][1], p[Nx][j][2]);
		}
		//-xii=0)
		glNormal3f(-1.0, 0.0, 0.0);
		for(j = 0; j < Ny; j++)
		{
			glVertex3f(p[0][j][0], p[0][j][1], 0.0f);
			glVertex3f(p[0][j][0], p[0][j][1], p[0][j][2]);
			glVertex3f(p[0][j+1][0], p[0][j+1][1], p[0][j+1][2]);
			glVertex3f(p[0][j+1][0], p[0][j+1][1], 0.0f);
		}
		//+yij=Ny)
		glNormal3f(0.0, 1.0, 0.0);
		for(i = 0; i < Nx; i++)
		{
			glVertex3f(p[i][Ny][0], p[i][Ny][1], 0.0f);
			glVertex3f(p[i][Ny][0], p[i][Ny][1], p[i][Ny][2]);
			glVertex3f(p[i+1][Ny][0], p[i+1][Ny][1], p[i+1][Ny][2]);
			glVertex3f(p[i+1][Ny][0], p[i+1][Ny][1], 0.0f);
		}
		//-yij=0)
		glNormal3f(0.0, -1.0, 0.0);
		for(i = 0; i < Nx; i++)
		{
			glVertex3f(p[i][0][0], p[i][0][1], 0.0f);
			glVertex3f(p[i+1][0][0], p[i+1][0][1], 0.0f);
			glVertex3f(p[i+1][0][0], p[i+1][0][1], p[i+1][0][2]);
			glVertex3f(p[i][0][0], p[i][0][1], p[i][0][2]);
		}
		glEnd();
	}
}

//-------------------------------------------------------------------
void drawFloor(float widthX, float widthZ, int nx, int nz)
{
  int i, j;
  //FloorP̕
  float wX = widthX / (float)nx;
  float wZ = widthZ / (float)nz;

  float diffuse[][4] = {
	{ 0.7, 0.7, 0.6, 1.0}, { 0.3f, 0.4, 0.4, 1.0} };
  float ambient[] = { 0.2, 0.2, 0.2, 1.0};
  float specular[]= { 0.5, 0.5, 0.5, 1.0};
  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
  glMaterialf(GL_FRONT,GL_SHININESS,100);

  glNormal3f(0.0, 1.0, 0.0);
  glPushMatrix();
  for (j = 0; j < nz; j++) 
  {
    float z1 = -widthZ / 2.0 + wZ * j; float z2 = z1 + wZ;
    for (i = 0; i < nx; i++) {
      float x1 = -widthX / 2.0 + wX * i; float x2 = x1 + wX;

      glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuse[(i + j) & 1]);
			glBegin(GL_QUADS);
      glVertex3f(x1, 0.0, z1);
      glVertex3f(x1, 0.0, z2);
      glVertex3f(x2, 0.0, z2);
      glVertex3f(x2, 0.0, z1);
			glEnd();
    }
  }
  glPopMatrix();
}

//-----------------------------------------------------------------------------
/*
//lp`̃bVix-y,S_j
//C̕Œ
void drawGrid(int Nx, int Ny, float sizeX, float sizeY, int sideFlag)
{
	//Ŝ̕,sizeX, sizeY
	//sideFlag = 0:ʕ\
	//sideFlag = 1:ʕ\
	const int NMAX = 130;
	int i, j;
	float p[NMAX][NMAX][3]; //_W
	float pitchX, pitchY;
//	float n1[3], n2[3], n3[3], n4[3];

	if(Nx > NMAX) printf("NxNMAX𒴂Ă܂(drawGrid) \n");
	if(Ny > NMAX) printf("NyNMAX𒴂Ă܂(drawGrid) \n");

	//Z̃TCY
	pitchX = sizeX / (float)Nx;
	pitchY = sizeY / (float)Ny;

	//e_̍W
	for(j = 0; j <= Ny; j++){
		for(i = 0; i <= Nx; i++){
			p[i][j][0] = (float)(i - Nx / 2) * pitchX;
			p[i][j][1] = (float)(j - Ny / 2) * pitchY;
			p[i][j][2] = 0.0;
		}
	}
		
	//Op`Ŗʂ`
	glNormal3f(0.0, 0.0, 1.0);//ׂz
	glBegin(GL_TRIANGLES);
	for(j = 0;j < Ny;j++)
		for(i = 0;i < Nx;i++)
		{
			//̎Op`
			//e_̖@,øW,_W^B
			glVertex3fv(p[i][j]);//غ݂̒_WiȉJԂj
			glVertex3fv(p[i+1][j]);
			glVertex3fv(p[i][j+1]);
			//E̎Op`
			glVertex3fv(p[i+1][j]);
			glVertex3fv(p[i+1][j+1]);
			glVertex3fv(p[i][j+1]);
		}
	glEnd();

	if(sideFlag == 1)//ʕ`
	{
		glBegin(GL_QUADS);
		//+xii=Nx)
		glNormal3f(1.0, 0.0, 0.0);
		for(j = 0; j < Ny; j++)
		{
			glVertex3f(p[Nx][j][0], p[Nx][j][1], 0.0f);
			glVertex3f(p[Nx][j+1][0], p[Nx][j+1][1], 0.0f);
			glVertex3f(p[Nx][j+1][0], p[Nx][j+1][1], p[Nx][j+1][2]);
			glVertex3f(p[Nx][j][0], p[Nx][j][1], p[Nx][j][2]);
		}
		//-xii=0)
		glNormal3f(-1.0, 0.0, 0.0);
		for(j = 0; j < Ny; j++)
		{
			glVertex3f(p[0][j][0], p[0][j][1], 0.0f);
			glVertex3f(p[0][j][0], p[0][j][1], p[0][j][2]);
			glVertex3f(p[0][j+1][0], p[0][j+1][1], p[0][j+1][2]);
			glVertex3f(p[0][j+1][0], p[0][j+1][1], 0.0f);
		}
		//+yij=Ny)
		glNormal3f(0.0, 1.0, 0.0);
		for(i = 0; i < Nx; i++)
		{
			glVertex3f(p[i][Ny][0], p[i][Ny][1], 0.0f);
			glVertex3f(p[i][Ny][0], p[i][Ny][1], p[i][Ny][2]);
			glVertex3f(p[i+1][Ny][0], p[i+1][Ny][1], p[i+1][Ny][2]);
			glVertex3f(p[i+1][Ny][0], p[i+1][Ny][1], 0.0f);
		}
		//-yij=0)
		glNormal3f(0.0, -1.0, 0.0);
		for(i = 0; i < Nx; i++)
		{
			glVertex3f(p[i][0][0], p[i][0][1], 0.0f);
			glVertex3f(p[i+1][0][0], p[i+1][0][1], 0.0f);
			glVertex3f(p[i+1][0][0], p[i+1][0][1], p[i+1][0][2]);
			glVertex3f(p[i][0][0], p[i][0][1], p[i][0][2]);
		}
		glEnd();
	}
}
*/